﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace 数组数据编辑器
{
    public partial class Form1 : Form
    {
        XmlDocument mydic; //xml数据
        String file_name; //文件名
        int id; //每行编号

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //路径：MessageBox.Show(Application.ExecutablePath);
        }

        //------------------------------------------各种函数------------------------------------------

        //载入XML文件并分析显示
        private void LoadXml(string Name)
        {
            mydic = new XmlDocument();
            mydic.Load(Name);
            XmlElement elm = mydic.DocumentElement;

            //listview清空
            listView1.Items.Clear();

            //重建所有列
            listView1.Columns.Clear();
            listView1.Columns.Add("id");
            listView1.Columns.Add("名称");
            listView1.Columns.Add("图标");
            listView1.Columns.Add("说明");
            listView1.Columns[1].Width = 100;
            listView1.Columns[2].Width = 100;
            listView1.Columns[3].Width = 400;

            id = 1;
            //从第一节点开始
            ToListBox(elm.FirstChild);
            

        }
        //将取得的结果显示在listview上
        private void ToListBox(XmlNode root)
        {
            if (root == null) return;

            if (root is XmlElement)
            {

                //创建一个新item用于显示
                ListViewItem item = new ListViewItem(id.ToString());

                //取得节点里的每个子节点
                foreach (XmlNode i in root)
                {
                    item.SubItems.Add(i.InnerText); 
                }

                //在列表里新增加一行
                listView1.Items.Add(item);
                id++;

                //如果有其他节点，重复此过程
                if (root.NextSibling != null)
                {
                    ToListBox(root.NextSibling);
                }

            }

        }

        //根据listview进行写入
        private void SaveMyXML(string file_name)
        {
            //根据当前列表进行处理

            string mytext = null;
            mytext = "<?xml version=\"1.0\" encoding=\"Unicode\"?>\n";
            mytext += "<VAR type=\"Array\" count=\""+listView1.Items.Count.ToString()+"\">\n";

            //添加每个item内容
            foreach (ListViewItem i in listView1.Items)
            {
                mytext+="<VAR type=\"Dictionary\">\n";
                mytext+="<VAR type=\"tvtString\" key=\"name\">"+i.SubItems[1].Text+"</VAR>\n";
                mytext+="<VAR type=\"tvtString\" key=\"icon\">"+i.SubItems[2].Text+"</VAR>\n";
                mytext += "<VAR type=\"tvtString\" key=\"intro\">" + i.SubItems[3].Text + "</VAR>\n";

                mytext += "</VAR>\n";
            }

            mytext += "</VAR>";

            StreamWriter sw;
            sw = new StreamWriter(file_name, false, Encoding.Unicode);
            sw.Write(mytext);
            sw.Close();
        }
        //------------------------------------------文件操作------------------------------------------

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //记录当前的文件名
                file_name = openFileDialog1.FileName;
                //在状态菜单栏显示文件名
                toolStripStatusLabel1.Text = file_name;
                //载入XML文件并分析
                LoadXml(file_name);
                //允许保存
                saveToolStripMenuItem.Enabled = true;
                saveAsToolStripMenuItem.Enabled = true;
                lineToolStripMenuItem.Enabled = true;
            }
        }

        //关闭
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        //保存
        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveMyXML(file_name);
            LoadXml(file_name);
        }

        //保存为
        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                file_name = saveFileDialog1.FileName;
                //在状态菜单栏显示文件名
                toolStripStatusLabel1.Text = file_name;

                SaveMyXML(file_name);
                LoadXml(file_name);
            }
        }
        //------------------------------------------行操作------------------------------------------

        //新增
        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 edit_form = new Form2();

            if (edit_form.ShowDialog() == DialogResult.OK)
            {

                //新增词条
                //创建一个新item用于显示
                ListViewItem item = new ListViewItem(id.ToString());

                item.SubItems.Add(edit_form.name);
                item.SubItems.Add(edit_form.icon);
                item.SubItems.Add(edit_form.intro);
                //在列表里新增加一行
                listView1.Items.Add(item);

            }
        }
        
        //插入
        private void insertToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 edit_form = new Form2();

            if (edit_form.ShowDialog() == DialogResult.OK)
            {

                //新增词条
                //创建一个新item用于显示
                ListViewItem item = new ListViewItem(id.ToString());

                item.SubItems.Add(edit_form.name);
                item.SubItems.Add(edit_form.icon);
                item.SubItems.Add(edit_form.intro);

                int ind;
                if (listView1.SelectedIndices != null && listView1.SelectedIndices.Count > 0)
                { ind = listView1.SelectedIndices[0]; }
                else
                { ind = id - 1; }

                //在列表里新增加一行
                listView1.Items.Insert(ind, item);
                reset_id();

            }
        }

        //删除
        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //假如词条总数>1 && 选中
            if (listView1.Items.Count > 1 && listView1.SelectedIndices != null && listView1.SelectedIndices.Count > 0)
            {
                //防止误操作
                if (MessageBox.Show("确定要删除这行喵？", "删除数据", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    int ind;
                    ind = listView1.SelectedIndices[0];
                    listView1.Items.RemoveAt(ind);
                    reset_id();
                }
            }
        }

        //重设id
        private void reset_id()
        {
            id = 1;

            foreach (ListViewItem i in listView1.Items)
            {
                i.SubItems[0].Text = id.ToString();
                id++;
            }
        }

        //选中一行
        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ind;

            if (listView1.SelectedIndices != null && listView1.SelectedIndices.Count > 0)
            { ind = listView1.SelectedIndices[0]; }
            else
            { ind = 0; }
            toolStripStatusLabel2.Text = (ind+1).ToString();
        }

        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            Form2 edit_form = new Form2();

            //调整窗口位置

            //传入参数
            edit_form.name = listView1.SelectedItems[0].SubItems[1].Text;
            edit_form.icon = listView1.SelectedItems[0].SubItems[2].Text;
            edit_form.intro = listView1.SelectedItems[0].SubItems[3].Text;

            //编辑后保存
            if (edit_form.ShowDialog() == DialogResult.OK)
            {
                listView1.SelectedItems[0].SubItems[1].Text = edit_form.name;
                listView1.SelectedItems[0].SubItems[2].Text = edit_form.icon;
                listView1.SelectedItems[0].SubItems[3].Text = edit_form.intro;
            }
        }

        private void openFileDialog2_FileOk(object sender, CancelEventArgs e)
        {

        }


    }
}
